{% from "components/display_testsuite_status.html.j2" import display_testsuite_status %}
{% from "components/display_status_icon.html.j2" import display_status_icon %}

{% macro card_header(metadata, index, type, view_report_button=false) %}
<div class="card-header">
    <div class="row">
        <div class="col-12">
            <h4 class="card-title mb-2">
                {{ display_status_icon(metadata["validation_status"], 30) }}{{ type.capitalize() }} Details for {{
                metadata.filepath }}
            </h4>
        </div>
        <div class="col-12 d-flex flex-column flex-md-row justify-content-end mt-2 mt-md-0">
            {% if view_report_button %}
            <a href="{{ metadata.htmlpath }}" class="btn btn-primary w-100 w-md-auto mb-2 mb-md-0 me-md-2" type="button">
                View File Report
            </a>
            {% endif %}
            <button class="btn btn-primary w-100 w-md-auto" type="button" data-bs-toggle="collapse"
                data-bs-target="#{{ type }}file-details-{{ index }}" aria-expanded="false"
                aria-controls="{{ type }}file-details-{{ index }}">
                Show/Hide Quick Details
            </button>
        </div>
    </div>
</div>
{% endmacro %}

{% macro card_body(metadata) %}
<div class="card-body">
    {% macro info_row_element(label, value) %}
    <div class="col-12 col-md-6">
        <p class="mb-0">
            <span class="fst-italic">{{ label }}: </span>
            <span class="text-secondary">{{ value }}</span>
        </p>
    </div>
    {% endmacro %}

    <div class="row mb-2">
        {{ info_row_element("Last Modified", metadata.file_metadata.last_modified_formatted) }}
        {{ info_row_element("Size in Bytes", "{:,}".format(metadata.file_metadata.size_in_bytes)) }}
        {{ info_row_element("File Path", metadata.filepath) }}
        {{ info_row_element("File Source", metadata.source) }}
    </div>
</div>
{% endmacro %}

{% macro schema_card(metadata, index) %}
<div class="card sticky-top m-2 m-md-5 shadow">
    {{ card_header(metadata, index, 'schema') }}
    {{ card_body(metadata) }}
    <div class="collapse" id="schemafile-details-{{ index }}">
        <div class="container">
            <p>Quality / Validation Overview:</p>
            {{ display_testsuite_status(metadata.testsuite_validation_status, metadata.test_cases, "schemafile-" ~ index
            ) }}
        </div>
        <div class="container">
            <p>Raw Schema Data:</p>
            <pre class="codebox"><code>{{ metadata.raw_data }}</code></pre>
        </div>
    </div>
</div>
{% endmacro %}

{% macro datafile_card(metadata, index, view_report_button=true) %}
<div class="card m-2 m-md-5 shadow">
    {{ card_header(metadata, index, 'data', view_report_button) }}
    {{ card_body(metadata) }}
    <div class="collapse" id="datafile-details-{{ index }}">
        <div class="container">
            <p>Quality / Validation Overview:</p>
            {{ display_testsuite_status(metadata.testsuite_validation_status, metadata.validation_testcases, "datafile-"
            ~ index) }}
        </div>
    </div>
</div>
{% endmacro %}
